#pragma once

struct ConsPair;



class MemoryRegion
{
private:
	MemoryRegion(const MemoryRegion & other);
	MemoryRegion & operator=(const MemoryRegion & other);
public:
	MemoryRegion();
	void SetData(void * data, size_t size);
	ConsPair * Cons();
	void Clear();
	bool Belongs(ConsPair * cons);
	size_t GetUsed();
	ConsPair * Get(size_t index);
private:
	ConsPair * m_data;
	size_t m_size;
	size_t m_used;
	size_t m_prevUsed;
};
