#pragma once

class MutableList;
extern MutableList RootList;
class RootPointer;
bool GCAdvance();
void GCCollect();
void GCDiagnostics();
RootPointer Cons(const RootPointer & car, const RootPointer & cdr);
void ScanPointer(RootPointer * rootPointer);
struct ConsPair;
struct MasterPointer;
ConsPair * MasterToCons(MasterPointer * ptr);
size_t RoundUpToPageSize(size_t size);
size_t GetPageSize();

extern const RootPointer Null;

int gcmain(int argc, _TCHAR* argv[]);
