#pragma once

class RootPointer;

class MutableList
{
private:
	MutableList(const MutableList & other);
	MutableList & operator=(const MutableList & other);
public:
	MutableList();
	void Link(RootPointer * item);
	void Unlink(RootPointer * item);
	void Start();
	RootPointer * Current();
	void Next();
	bool IsLast(RootPointer * item);
private:
	RootPointer * m_head;
	RootPointer * m_tail;
	RootPointer * m_iterator;
};
